using System.Data;
using System.IO;
using System;
using System.Runtime.Serialization.Formatters.Binary;
using Dynamicweb;

namespace CustomDealersearch
{
	[Serializable()]
	public class Category
	{
		private int _ID = 0;
		private string _Name = "";
		private DealerCollection _Dealers;

		public int ID {
			get { return _ID; }
			set { _ID = value; }
		}

		public string Name {
			get { return _Name; }
			set { _Name = value; }
		}

		public DealerCollection Dealers {
			get {
				if (_Dealers == null)
				{
					_Dealers = new DealerCollection(this.ID);
				}
				return _Dealers;
			}
			set { _Dealers = value; }
		}

		public Category()
		{
		}

		public void Fill(IDataReader DataReader)
		{
			_ID = Base.ChkNumber(DataReader["DealerSearchCategoryID"]);
			_Name = Base.ChkString(DataReader["DealerSearchCategoryName"]);
		}

		public void Save()
		{
			DataSet objDataset = new DataSet();
			DataRow objRow;
			string SQL = "SELECT * FROM DealerSearchCategory WHERE DealerSearchCategoryID = " + _ID;

			DataManager dbMan = new DataManager();
			try {
				objDataset = dbMan.getDataSet("DealerSearch.mdb", SQL);

				if (_ID != 0)
				{
					objRow = objDataset.Tables[0].Rows[0];
				}
				else
				{
					objRow = objDataset.Tables[0].NewRow();
					objDataset.Tables[0].Rows.Add(objRow);
				}

				objRow["DealerSearchCategoryName"] = _Name;

				dbMan.updateDataSet(objDataset);

				if (_ID == 0)
				{
					_ID = dbMan.getIdentity();
				}
			}
			catch  {
			}
			finally {
				objDataset.Dispose();
				dbMan.Dispose();
			}
		}

		public void Delete()
		{
			if (_ID != 0)
			{
				Delete(_ID);
			}
		}

		public static void Delete(int ID)
		{
			Database.ExecuteNonQuery("DELETE FROM DealerSearchCategory WHERE DealerSearchCategoryID = " + ID, "DealerSearch.mdb");
		}

		public Category Copy()
		{
			Category objCategory = new Category();
			objCategory = this.Clone();
			objCategory.ID = 0;
			objCategory.Name = "Copy of " + objCategory.Name;
			objCategory.Save();
			return objCategory;
		}

		public Category Clone()
		{
			//This is why the class is serializable.
			MemoryStream memStream = new MemoryStream();
			BinaryFormatter binFormatter = new BinaryFormatter();

			binFormatter.Serialize(memStream, this);
			memStream.Position = 0;
			return (Category)binFormatter.Deserialize(memStream);
		}

		public static CategoryCollection AllCategories()
		{
			CategoryCollection myCol = new CategoryCollection();
			Category objCategory;

			using (IDataReader objDataReader = Database.getDataReader("SELECT * FROM DealerSearchCategory ORDER BY DealerSearchCategoryID", "DealerSearch.mdb")) {
				while (objDataReader.Read()) {
					objCategory = new Category();
					objCategory.Fill(objDataReader);
					myCol.Add(objCategory);
				}
			}

			return myCol;
		}

		public static Category GetCategoryById(int CategoryID)
		{
			Category Cat = null;
			using (IDataReader objDataReader = Database.getDataReader("SELECT * FROM DealerSearchCategory WHERE DealerSearchCategoryID = " + CategoryID, "DealerSearch.mdb")) {
				if (objDataReader.Read())
				{
					Cat = new Category();
					Cat.Fill(objDataReader);
				}
			}
			return Cat;
		}

	}
}
